SystemOrganization addCategory: #'Scriptaculous-Tests-Components'!

!WAPackage class methodsFor: '*Scriptaculous-Tests-Components' stamp: 'jf 10/23/2008 12:05'!
scriptaculousTestsComponents
	^ self new
		name: 'Scriptaculous-Tests-Components';
		description: 'foo';
		addDependency: 'Scriptaculous-Components';
		addDependency: 'Seaside-Tests-Component';
		yourself! !

WAComponent subclass: #SUSmallBoxTest
	instanceVariableNames: 'text'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scriptaculous-Tests-Components'!

!SUSmallBoxTest methodsFor: 'testing' stamp: 'obi 2/15/2008 20:49'!
coreClass
	"Answer the actual implementation of the feature."
	
	^ nil! !

!SUSmallBoxTest methodsFor: 'rendering' stamp: 'obi 2/15/2008 21:02'!
renderContentOn: html
	html div class: 'smallBox'; with: [
		html div class: 'header'.
		html div 
			class: 'content';
			with: text ]! !

!SUSmallBoxTest methodsFor: 'testing' stamp: 'obi 2/15/2008 20:49'!
testClass
	"Answer the class that represents this example."
	
	^ self class! !

!SUSmallBoxTest methodsFor: 'accessing' stamp: 'obi 2/15/2008 21:03'!
text
	^ text! !

!SUSmallBoxTest methodsFor: 'accessing' stamp: 'obi 2/15/2008 21:03'!
text: anObject
	text := anObject! !

WAComponent subclass: #SUTooltipTest
	instanceVariableNames: 'text'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scriptaculous-Tests-Components'!

!SUTooltipTest class methodsFor: 'accessing' stamp: 'obi 7/23/2008 20:53'!
tooltips
	| dict |
	dict := Dictionary new.
	dict at: #hello put: 'Hello world!!'.
	dict at: #ok put: 'This is the ok button!!'.
	^dict! !

!SUTooltipTest methodsFor: 'initialize-release' stamp: 'obi 7/26/2008 18:58'!
initialize
	super initialize.
	text := ''! !

!SUTooltipTest methodsFor: 'rendering' stamp: 'obi 7/22/2008 20:30'!
renderContentOn: html
	html text: text! !

!SUTooltipTest methodsFor: 'accessing' stamp: 'obi 7/22/2008 20:31'!
text: aText
	text := aText! !

!SUTooltipTest methodsFor: 'accessing' stamp: 'obi 7/23/2008 20:21'!
textWithKey: aKey
	self text: (self class tooltips at: aKey asSymbol ifAbsent: ['Tooltip for key "', aKey , '" not found!!'])! !

SUFunctionalTest subclass: #SUAccordionTest
	instanceVariableNames: 'accordion'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scriptaculous-Tests-Components'!

!SUAccordionTest methodsFor: 'accessing' stamp: 'pmm 1/3/2008 17:20'!
children
	^Array with: accordion! !

!SUAccordionTest methodsFor: 'accessing' stamp: 'lr 1/4/2008 14:01'!
coreClass
	^ SUAccordion! !

!SUAccordionTest methodsFor: 'initialize-release' stamp: 'lr 1/4/2008 13:56'!
initialize
	super initialize.
	accordion := SUAccordion new
		add: (SUCounterTest on: 1) label: 'Counter 1';
		add: (SUCounterTest on: 2) label: 'Counter 2';
		add: (SUCounterTest on: 3) label: 'Counter 3';
		yourself! !

SUFunctionalTest subclass: #SUCarouselHorizontalTest
	instanceVariableNames: 'carousel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scriptaculous-Tests-Components'!

!SUCarouselHorizontalTest methodsFor: 'accessing' stamp: 'obi 2/13/2008 21:20'!
children
	^Array with: carousel! !

!SUCarouselHorizontalTest methodsFor: 'accessing' stamp: 'obi 2/13/2008 21:20'!
coreClass
	^ SUHorizontalCarousel! !

!SUCarouselHorizontalTest methodsFor: 'initialize-release' stamp: 'obi 2/15/2008 21:04'!
initialize
	super initialize.
	carousel := SUHorizontalCarousel new.
	carousel elementExtent: (Point x: 80 y: 80).
	1 to: 50 do: [:idx | carousel add: (SUSmallBoxTest new text: 'Test Box: ', idx asString; yourself)].
	! !

SUFunctionalTest subclass: #SUCarouselTest
	instanceVariableNames: 'carousel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scriptaculous-Tests-Components'!

!SUCarouselTest methodsFor: 'accessing' stamp: 'obi 1/12/2008 11:20'!
children
	^Array with: carousel! !

!SUCarouselTest methodsFor: 'accessing' stamp: 'obi 2/13/2008 20:09'!
coreClass
	^ SUNavigationCarousel! !

!SUCarouselTest methodsFor: 'initialize-release' stamp: 'obi 2/13/2008 20:08'!
initialize
	super initialize.
	carousel := SUNavigationCarousel new.
	1 to: 10 do: [:idx | carousel add: (SUCounterTest on: idx) label: 'Counter ', idx asString].


	! !

SUFunctionalTest subclass: #SUCarouselVerticalTest
	instanceVariableNames: 'carousel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scriptaculous-Tests-Components'!

!SUCarouselVerticalTest methodsFor: 'accessing' stamp: 'obi 2/16/2008 11:01'!
children
	^Array with: carousel! !

!SUCarouselVerticalTest methodsFor: 'accessing' stamp: 'obi 2/16/2008 11:01'!
coreClass
	^ SUHorizontalCarousel! !

!SUCarouselVerticalTest methodsFor: 'initialize-release' stamp: 'obi 2/17/2008 12:43'!
initialize
	super initialize.
	carousel := SUVerticalCarousel new.
	carousel elementExtent: (Point x: 370 y: 60); numVisible: 3; scrollInc: 3; navMargin: 14; animationSpeed: 0.3.
	1 to: 20 do: [:idx | carousel add: (SUSmallBoxTest new text: 'Test Box: ', idx asString; yourself)].
	! !

SUFunctionalTest subclass: #SUDatePickerTest
	instanceVariableNames: 'component'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scriptaculous-Tests-Components'!

!SUDatePickerTest methodsFor: 'accessing' stamp: 'obi 1/16/2008 20:47'!
children
	^Array with: component! !

!SUDatePickerTest methodsFor: 'accessing' stamp: 'obi 1/16/2008 19:55'!
coreClass
	^ SUDatePicker! !

!SUDatePickerTest methodsFor: 'initialize-release' stamp: 'obi 1/16/2008 21:06'!
initialize
	super initialize.
	component := nil." SUDatePicker new."! !

!SUDatePickerTest methodsFor: 'rendering' stamp: 'obi 1/16/2008 21:32'!
renderContentOn: html
	| theId buttonId | 
	component := nil.
	theId := html nextId.
	buttonId := html nextId.
	html form: [html table: [
				html tableRow: [
					html tableData verticalAlign: 'top'; with: [html textInput id: theId].
					html tableData: [html button id: buttonId; value: 'Set date';
								onClick: (html evaluator callback: [:script | self setupDatePickerOn: theId button: buttonId script: script];
												return: false)].
					 ] ] ].
! !

!SUDatePickerTest methodsFor: 'rendering' stamp: 'obi 1/16/2008 21:48'!
setupDatePickerOn: theId button: buttonId script: script
	component ifNil: [component := SUDatePicker on: theId button: buttonId].
	script element id: buttonId; styleAt: 'display' put: 'none'; insertAfter: component! !

SUFunctionalTest subclass: #SUHorizontalSplitterTest
	instanceVariableNames: 'splitter'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scriptaculous-Tests-Components'!

!SUHorizontalSplitterTest methodsFor: 'accessing' stamp: 'obi 5/4/2008 21:04'!
children
	^ Array with: splitter! !

!SUHorizontalSplitterTest methodsFor: 'accessing' stamp: 'obi 5/4/2008 21:01'!
coreClass
	^ SUHorizontalSplitter! !

!SUHorizontalSplitterTest methodsFor: 'initialize-release' stamp: 'obi 5/5/2008 20:49'!
initialize
	super initialize.
	splitter := SUHorizontalSplitter new
		add: (SUCounterTest on: 1) size: '50px' min: 30;
		add: (SUCounterTest on: 2) size: '50px' min: 30;
		add: (SUCounterTest on: 3) size: '50px' min: 30;
		yourself! !

SUFunctionalTest subclass: #SULightboxTest
	instanceVariableNames: 'value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scriptaculous-Tests-Components'!

!SULightboxTest methodsFor: 'user interface' stamp: 'RJT 5/8/2007 12:43'!
inform: aString
	self lightbox: (WAFormDialog new addMessage: aString; yourself).
	self lightbox: (WAFormDialog new addMessage: 'Back for more'; yourself)! !

!SULightboxTest methodsFor: 'rendering' stamp: 'sh 8/30/2008 17:58'!
renderContentOn: html
	html form
		style: 'text-align: center';
		with:[
			html div: [
				html text: 'What is your favorite transportation system ?'.
				3 timesRepeat:[html break].
				html select
					list:    #(Automobile Airplane Truck Boat Bicycle Horse Walking Swimming);
					selected: value;
					callback: [:v | value := v].
				html submitButton value: 'Ok'; callback: [self inform: value]]]! !

!SULightboxTest methodsFor: 'rendering' stamp: 'obi 7/28/2008 22:01'!
style
	^'
div#lightbox {
	background: white;
	border: 1px solid #0000e8;
	padding: 2em;
	width: 40em;
	text-align: center;
}
div#overlay {
	background-color: black;
	filter: alpha(opacity=30);
	-moz-opacity: 0.3;
	opacity: 0.3;
}
'! !

SUFunctionalTest subclass: #SUTabPanelTest
	instanceVariableNames: 'tabPanel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scriptaculous-Tests-Components'!

!SUTabPanelTest methodsFor: 'accessing' stamp: 'lr 1/4/2008 11:26'!
children
	^ Array with: tabPanel! !

!SUTabPanelTest methodsFor: 'accessing' stamp: 'lr 1/4/2008 14:02'!
coreClass
	^ SUTabPanel! !

!SUTabPanelTest methodsFor: 'initialize-release' stamp: 'lr 1/4/2008 11:28'!
initialize
	super initialize.
	tabPanel := SUTabPanel new
		add: (SUCounterTest on: 1) label: 'Counter 1';
		add: (SUCounterTest on: 2) label: 'Counter 2';
		add: (SUCounterTest on: 3) label: 'Counter 3';
		yourself! !

!SUTabPanelTest methodsFor: 'updating' stamp: 'lr 1/4/2008 11:38'!
updateRoot: anHtmlRoot
	super updateRoot: anHtmlRoot.
	anHtmlRoot stylesheet url: SUComponentLibrary / #tabPanelCss! !

SUFunctionalTest subclass: #SUTieredListTest
	instanceVariableNames: 'tieredList'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scriptaculous-Tests-Components'!

!SUTieredListTest methodsFor: 'accessing' stamp: 'pmm 1/3/2008 17:25'!
children
	^Array with: tieredList! !

!SUTieredListTest methodsFor: 'accessing' stamp: 'lr 1/4/2008 14:02'!
coreClass
	^ SUTieredList! !

!SUTieredListTest methodsFor: 'initialize-release' stamp: 'lr 1/4/2008 11:23'!
initialize
	super initialize.
	tieredList := SUTieredList new
		labels: [ :value | value fullName ];
		children: [ :value | 
			value subclasses
				asSortedCollection: [ :a :b | a name < b name ] ];
		selection: (OrderedCollection with: Collection);
		yourself! !

SUFunctionalTest subclass: #SUTitlePaneTest
	instanceVariableNames: 'component'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scriptaculous-Tests-Components'!

!SUTitlePaneTest methodsFor: 'accessing' stamp: 'obi 1/13/2008 21:34'!
children
	^Array with: component! !

!SUTitlePaneTest methodsFor: 'accessing' stamp: 'obi 1/14/2008 20:40'!
coreClass
	^ SUTitlePane! !

!SUTitlePaneTest methodsFor: 'initialize-release' stamp: 'obi 1/14/2008 20:40'!
initialize
	super initialize.
	component := self coreClass new title: 'Title';
		body: (SUFormTest new)
"		body: (SUCounterTest on: 1); yourself"
		
"		body: (SUCarouselTest new); yourself"

	


	! !

SUFunctionalTest subclass: #SUTreeReportTest
	instanceVariableNames: 'treeReport'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scriptaculous-Tests-Components'!

!SUTreeReportTest methodsFor: 'accessing' stamp: 'lr 11/29/2007 14:53'!
children
	^ Array with: treeReport! !

!SUTreeReportTest methodsFor: 'accessing' stamp: 'lr 1/4/2008 14:02'!
coreClass
	^ SUTreeReport! !

!SUTreeReportTest methodsFor: 'initialize-release' stamp: 'lr 1/4/2008 12:34'!
initialize
	super initialize.
	treeReport := SUTreeReport new
		expand: Collection;
		roots: (Array with: Collection);
		children: [ :value | 
			value subclasses
				asSortedCollection: [ :a :b | a name < b name ] ];
		addColumn: [ :value | value name ]
			label: 'Class Name';
		addColumn: [ :value |
			[ :html |
				value instVarNames
					do: [ :each | html text: each ]
					separatedBy: [ html text: ', ' ] ] ]
			label: 'Instance Variables';
		yourself! !

SUFunctionalTest subclass: #SUVerticalSplitterTest
	instanceVariableNames: 'splitter'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scriptaculous-Tests-Components'!

!SUVerticalSplitterTest methodsFor: 'accessing' stamp: 'obi 5/4/2008 21:08'!
children
	^ Array with: splitter! !

!SUVerticalSplitterTest methodsFor: 'accessing' stamp: 'obi 5/4/2008 21:08'!
coreClass
	^ SUVerticalSplitter! !

!SUVerticalSplitterTest methodsFor: 'initialize-release' stamp: 'obi 5/5/2008 20:50'!
initialize
	super initialize.
	splitter := SUVerticalSplitter new
		add: (SUCounterTest on: 1) size: '150px' min: 60;
		add: (SUCounterTest on: 2) size: '150px' min: 80;
		add: (SUCounterTest on: 3) size: '150px' min: 80;
		yourself! !

SUFunctionalTest subclass: #SUWindowTest
	instanceVariableNames: 'windows'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scriptaculous-Tests-Components'!

!SUWindowTest methodsFor: 'accessing' stamp: 'obi 6/26/2008 20:48'!
children
	^windows! !

!SUWindowTest methodsFor: 'accessing' stamp: 'obi 6/24/2008 20:47'!
coreClass
	^ SUWindow! !

!SUWindowTest methodsFor: 'initialize-release' stamp: 'obi 8/30/2008 14:34'!
initialize
	super initialize.
	windows := OrderedCollection 
					with: ((SUWindow on: [:w | SUCounterTest on: 10]) id: 'window_1'; zIndex: 1000; title: 'Window 1'; yourself)
					with: ((SUWindow on: [:w | SUFormTest new]) id: 'window_2';
								zIndex: 1001;
								origin: (300@100);
								extent: 500@240;
								title: 'Window 2';
								yourself)
					with: ((SUWindow on: [:w | SUTooltipTest new]) id: 'window_3';
								updateBlock: [:w :model | model textWithKey: (w tooltipKey)];
								zIndex: 1003;
								extent: 150@45;
								title: 'Tooltip';
								closeButtonEnabled: false;
								minimizeButtonEnabled: false;
								yourself)! !

!SUWindowTest methodsFor: 'rendering' stamp: 'obi 7/23/2008 20:38'!
renderContentOn: html 
	| aWindow |
	html big: 'Window Test:'.
	html space.
	html anchor
		onClick: (html evaluator callback: [ : script | windows first openOn: script ]) ;
		with: 'Open window 1'.
	html space: 2.
	html anchor
		onClick: (html evaluator callback: [ : script | (windows at: 2) openOn: script ]) ;
		with: 'Open window 2'.
	html space: 2.
	aWindow := windows last.
	html anchor
		class: 'tt' ;
		attributeAt: 'rel'
			put: 'ok' ;
		with: 'Show tooltip 1'.
	html space: 2.
	html anchor
		class: 'tt' ;
		attributeAt: 'rel'
			put: 'hello' ;
		with: 'Show tooltip 2'.
	html space: 2.
	html anchor
		class: 'tt' ;
		attributeAt: 'rel'
			put: 'illegal' ;
		with: 'Show tooltip 3'.
	windows do: [:w | html render: w ].
	self 
		tooltipScriptOn: html
		window: aWindow! !

!SUWindowTest methodsFor: 'scripting' stamp: 'lr 10/14/2008 00:43'!
tooltipScriptOn: html window: aWindow
	"add an event handler to all anchors which have the class tt"
	"use the html rel attribute as tooltip index"
	
	self requestContext addLoadScript: (html selector
     	add: 'a.tt';
     	do: [ :each | each element on: 'mouseover' do: ((JSStream on: 'event.target._showState = true'),
				((JSStream on: 'event.target._showState') then:
					(html evaluator 
						callback: [:v | aWindow initializeTooltipWith: v ] value: (JSStream on: '[event.clientX,event.clientY,event.target.rel]');
						callback: [:script | aWindow openOn: script hidden: true];
						onComplete: ((JSStream on: 'event.target._showState') then: (html element id: aWindow windowId; show))); timeout: 2000)).
				each element on: 'mouseout' do: 	((JSStream on: 'event.target._showState = false'),
					((html element id: aWindow windowId; visible) then:
						(html evaluator 
							callback: [:script | aWindow closeOn: script])))
					])

	! !

SUAllTests subclass: #SUAllComponentTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scriptaculous-Tests-Components'!

!SUAllComponentTests class methodsFor: 'accessing' stamp: 'lr 8/30/2008 11:54'!
description
	^ 'Functional Scriptaculous Component Test Suite'! !

!SUAllComponentTests class methodsFor: 'initialization' stamp: 'lr 8/30/2008 11:59'!
initialize
	(self registerAsApplication: 'tests/scriptaculous-components')
		addLibrary: SULibrary;
		addLibrary: SUAllTestLibrary;
		addLibrary: SUComponentLibrary! !

!SUAllComponentTests methodsFor: 'initialization' stamp: 'lr 8/30/2008 11:53'!
initializeTabs
	tabs := OrderedCollection new
		add: 'Welcome' -> (Array
			with: 'Welcome' -> SUWelcomeTest new
			with: 'Counter' -> SUCounterTest new);
		add: 'Window' -> (Array
			with: 'Window' -> SUWindowTest new
			with: 'Lightbox' -> SULightboxTest new
			with: 'TitlePane' -> SUTitlePaneTest new
			with: 'Splitter Vertical'-> SUVerticalSplitterTest new
			with: 'Splitter Horizontal'-> SUHorizontalSplitterTest new);
		add: 'Navigation' -> (Array
			with: 'TabPanel' -> SUTabPanelTest new
			with: 'Accordion' -> SUAccordionTest new
			with: 'Carousel' -> SUCarouselTest new
			with: 'Carousel Horizontal'-> SUCarouselHorizontalTest new
			with: 'Carousel Vertical'-> SUCarouselVerticalTest new);
		add: 'Controls' -> (Array
			with: 'TieredList' -> SUTieredListTest new
			with: 'TreeReport' -> SUTreeReportTest new
			with: 'DatePicker' -> SUDatePickerTest new);
		yourself! !

!SUAllComponentTests methodsFor: 'accessing' stamp: 'lr 8/30/2008 11:59'!
title
	^ super title , ' Components'! !
SUAllComponentTests initialize!
